/** @type {import('./$types').LayoutLoad} */
// console.log(`IDAA BB - [account_id] +layout.ts start`);

// import { error } from '@sveltejs/kit';
import { browser } from '$app/environment';
import { archives_func } from '$lib/ae_archives/ae_archives_functions';

export async function load({ fetch, params, parent }) {
    // route
    const log_lvl: number = 0;

    const data = await parent();
    data.log_lvl = log_lvl;

    const account_id = data.account_id;
    let ae_acct = data[account_id];

    if (!ae_acct) {
        console.warn(
            `ae IDAA Archives +layout.ts: Account ${account_id} not found in data. Initializing ghost acct.`
        );
        ae_acct = {
            api: data.ae_api || {},
            slct: {
                account_id: account_id
            }
        };
    }

    if (browser) {
        const load_archive_obj_li = archives_func.load_ae_obj_li__archive({
            api_cfg: ae_acct.api,
            for_obj_type: 'account',
            for_obj_id: account_id,
            inc_content_li: false,
            enabled: 'enabled',
            hidden: 'not_hidden',
            limit: 29,
            order_by_li: {
                priority: 'DESC',
                sort: 'DESC',
                updated_on: 'DESC',
                created_on: 'DESC',
                name: 'ASC'
            },
            params: params,
            try_cache: true,
            log_lvl: log_lvl
        });
        if (log_lvl) {
            console.log(`load_archive_obj_li = `, load_archive_obj_li);
        }
        ae_acct.slct.archive_obj_li = load_archive_obj_li;
    }

    // WARNING: Precaution against shared data between sites and sessions.
    data[account_id] = ae_acct;

    return data;
}
